/* ledswitch
 A beépített piros LED vezérlése az SW2 nyomógomb segítségével:
 - első lenyomásra a piros LED világítson
 - második lenyomásra a LED kialszik
 - harmadik lenyomásra a LED villog
 */

boolean waitforpress = true;     //Kezdetben lenyomásra várunk 
int led_state = 0;               //Kezdetben a LED ki van kapcsolva
int timecount = 25;              //Villogás félperiódusának ideje

void setup() {
  pinMode(RED_LED,OUTPUT);       //legyen kimenet
  pinMode(PUSH2,INPUT_PULLUP);   //Bemenet beslő felhúzással
}

void loop() {
  if(waitforpress) {             //Ha lenyomásra várunk és
    if(!digitalRead(PUSH2)) {    //Ha lenyomás történt...
      if(++led_state > 2) led_state = 0;  //Állapot léptetése (2 után körülfordulás...)
      digitalWrite(RED_LED, led_state); //LED állapot beállítása
      waitforpress = false;      //Következő stáció: felengedésre várunk
    }
  }  
  else {                         //Ha felengedésre vártunk és
    if(digitalRead(PUSH2)) {     //Ha felengedést észlelünk...
      waitforpress = true;       //Következő stáció: lenyomásra várunk
    }
  }  
  delay(20);                     //pergésmentesítő késleltetés
  if(led_state == 2)             //Ha villogtatás állapotban vagyunk
    if(--timecount == 0) {       //Ha az eltelt idő 25*20 ms, akkor
      digitalWrite(RED_LED,!digitalRead(RED_LED)); //LED állapot átbillentése
      timecount = 25;            //Következő billentés újabb 25*20 ms múlva...
    }
} 


